﻿/// <reference path="../../../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../../../Resources/TypeDefinitions/select2/select2.d.ts"/>
/// <reference path="../../../rubbish.ts"/>
var PullMavenArtifactPage;
(function (PullMavenArtifactPage) {
    function Init(o) {
        var input = o;

        var handleInitSelection = function (element, callback) {
            var value = $(element).val();
            if (value) {
                callback({
                    id: value,
                    text: value
                });
            }
        };

        $('#' + input.ctlGroupId).select2({
            initSelection: handleInitSelection,
            minimumInputLength: 1,
            ajax: {
                url: input.searchGroupsUrl,
                dataType: 'json',
                quietMillis: 250,
                data: function (term, page) {
                    return {
                        feedId: input.feedId,
                        repo: $('#' + input.ctlRepository).val(),
                        term: term
                    };
                },
                results: function (data) {
                    return {
                        results: data.map(function (g) {
                            return {
                                id: g,
                                text: g
                            };
                        })
                    };
                }
            }
        });

        $('#' + input.ctlArtifactId).select2({
            initSelection: handleInitSelection,
            ajax: {
                minimumInputLength: 1,
                url: input.searchArtifactsUrl,
                dataType: 'json',
                quietMillis: 250,
                data: function (term, page) {
                    return {
                        feedId: input.feedId,
                        repo: $('#' + input.ctlRepository).val(),
                        groupId: $('#' + input.ctlGroupId).val(),
                        term: term
                    };
                },
                results: function (data) {
                    return {
                        results: data.map(function (t) {
                            return {
                                g: t.g,
                                id: t.a,
                                text: t.a
                            };
                        })
                    };
                }
            }
        });

        $('#' + input.ctlVersions).select2({
            initSelection: handleInitSelection,
            multiple: true,
            placeholder: '(pull all artifact versions)',
            ajax: {
                url: input.searchVersionsUrl,
                dataType: 'json',
                quietMillis: 250,
                data: function (term, page) {
                    return {
                        feedId: input.feedId,
                        repo: $('#' + input.ctlRepository).val(),
                        groupId: $('#' + input.ctlGroupId).val(),
                        artifactId: $('#' + input.ctlArtifactId).val(),
                        term: term
                    };
                },
                results: function (data) {
                    return {
                        results: data.map(function (v) {
                            return {
                                id: v,
                                text: v
                            };
                        })
                    };
                }
            }
        });
    }
    PullMavenArtifactPage.Init = Init;
})(PullMavenArtifactPage || (PullMavenArtifactPage = {}));
